% on dfinit le primtre de vue  0, on voit toute la carte
setViewPerimeter(0, 0).

/* ------------------------------------------------
   Prdicat gnral */

   %  move(L, X, Y, Pos, Size, CanGotoExit, Dx, Dy)
   % L : map list
   % X, Y : miner coordinates
   % Pos : miner position in the map list
   % Size : map width
   % CanGotoExit : 1 if miner can leave map
   % Dx : miner next horizontal move
   % Dy : miner next vertical move


% On doit traiter toute la carte
move(L, X, Y, _, Size, _, 0, 0)
:- mustDealMap([X, Y], Size),            % /SI\ on doit traiter la carte
   debug('mineur : '), debug(X), debug(' '), debugN(Y),
   debugN('====== first deal'),
   dealList(L, Size, Map),               % on traite la carte
   debugN('dealed'),
   save(mustDealMap, false),             % on dit que la carte ne doit plus tre traite en premier passage
   save(mapHasMoved, true),              % on dit que la carte a boug cette image et que l'on va devoir anticiper les mouvements de la carte
   debugN('recorded'),
   saveMap(Map),                         % on enregistre la carte traite
   debugN('saved'),
   save(mustRedealMap, true),            % on doit faire un second passage sur la map
   save(way, []),
   saveMinorOldPos([X,Y]), !.

 % On doit retraiter toute la carte
move(L, X, Y, _, _, CanGotoExit, Dx, Dy)
:- recorded(mustRedealMap, true),   % /SI\ on doit retraiter la carte
   debugN('====== second deal'),
   loadMap(OldMap),                 % on rcupre la map de l'image prcdente
   debugN('loaded'),
   %redealMap(L, OldMap, Map),       % on traite la carte completement ( deuxime passage )
   updateMap(L, OldMap, Map),       % on traite la carte completement ( deuxime passage )
   debugN('updated'),
   save(mustRedealMap, false),      % on dit que la carte ne doit plus tre traite
   debugN('recorda'),
   %actionMiniThenFull(Map, [X, Y], CanGotoExit, [Dx, Dy]), !.
   action(Map, [X, Y], CanGotoExit, [Dx, Dy]),
   debugN('actioned'), !.

% Dans les autres cas
 move(L, X, Y, _, _, CanGotoExit, Dx, Dy)
 :- debugN('====== other deal'),
    loadMap(OldMap),                % on rcupre la map
    updateMap(L, OldMap, Map),      % on actualise la map
    %actionMiniThenFull(Map, [X, Y], CanGotoExit, [Dx, Dy]), !.
    action(Map, [X, Y], CanGotoExit, [Dx, Dy]), !.
    
    